<?php
require_once 'SignatureUtils.php';
 
class ButtonGenerator {
	const SIGNATURE_KEYNAME = "signature";
        const SIGNATURE_METHOD_KEYNAME = "signatureMethod";
        const SIGNATURE_VERSION_KEYNAME = "signatureVersion";
        const HMAC_SHA1_ALGORITHM = "HmacSHA1";
        const HMAC_SHA256_ALGORITHM = "HmacSHA256";
	const SIGNATURE_VERSION = "2";
        const COBRANDING_STYLE = "logo";

	private static $httpMethod = "POST";
        public static  $SANDBOX_END_POINT = "https://authorize.payments-sandbox.amazon.com/pba/paypipeline";
        public static  $SANDBOX_IMAGE_LOCATION="https://authorize.payments-sandbox.amazon.com/pba/images/SMSubscribeWithOutLogo.png";
        public static  $PROD_END_POINT = "https://authorize.payments.amazon.com/pba/paypipeline";
        public static  $PROD_IMAGE_LOCATION="https://authorize.payments.amazon.com/pba/images/SMSubscribeWithOutLogo.png";
	
	 

	public static function getSubscriptionParams($accessKey,$amount, $description, $referenceId, $immediateReturn,
			$returnUrl, $abandonUrl, $processImmediate, $ipnUrl, $collectShippingAddress,  
			$signatureMethod,$recurringFrequency,$subscriptionPeriod,$recurringStartDate,$promotionAmount,$noOfPromotionTransactions ) {
		$cobrandingStyle= self::COBRANDING_STYLE;
		$formHiddenInputs = array();
		if($accessKey!=null) $formHiddenInputs["accessKey"] = $accessKey;
		else throw new Exception("Accesskey is Required");
		if($amount!=null) $formHiddenInputs["amount"] = $amount;
		else throw new Exception("Amount is required");
		if($description!=null) $formHiddenInputs["description"] = $description;
		else throw new Exception("Description is required");
		if($recurringFrequency!=null) $formHiddenInputs["recurringFrequency"] = $recurringFrequency;
		else throw new Exception("RecurringFrequency is required");
		if($signatureMethod!=null) $formHiddenInputs[self::SIGNATURE_METHOD_KEYNAME] = $signatureMethod;
                else throw new Exception("Signature Method is required");		
		if ($referenceId != null) $formHiddenInputs["referenceId"] = $referenceId;
		if ($immediateReturn != null) $formHiddenInputs["immediateReturn"] = $immediateReturn;
		if ($returnUrl != null) $formHiddenInputs["returnUrl"] = $returnUrl;
		if ($abandonUrl != null) $formHiddenInputs["abandonUrl"] = $abandonUrl;
		if ($processImmediate != null) $formHiddenInputs["processImmediate"] = $processImmediate;
		if ($ipnUrl != null) $formHiddenInputs["ipnUrl"] = $ipnUrl;
		if ($cobrandingStyle != null) $formHiddenInputs["cobrandingStyle"] = $cobrandingStyle;
		if ($collectShippingAddress != null) $formHiddenInputs["collectShippingAddress"] = $collectShippingAddress;

		if ($subscriptionPeriod != null) $formHiddenInputs["subscriptionPeriod"]= $subscriptionPeriod;
	        if ($recurringStartDate != null) $formHiddenInputs["recurringStartDate"]=$recurringStartDate;
       		if ($promotionAmount != null) $formHiddenInputs["promotionAmount"]= $promotionAmount;
       		if ($noOfPromotionTransactions != null) $formHiddenInputs["noOfPromotionTransactions"]= $noOfPromotionTransactions;
		
	
		$formHiddenInputs[self::SIGNATURE_VERSION_KEYNAME] = self::SIGNATURE_VERSION;
		return $formHiddenInputs;
	}
	 
	public static function getSubscriptionForm(array $formHiddenInputs,$endPoint,$imageLocation) {

		$form = "";
		$form .=  "<form action=\""; 
		$form .= $endPoint;
		$form .= "\" method=\"";
		$form .= self::$httpMethod . "\">\n";
		$form .= "<input type=\"image\" src=\"".$imageLocation."\" border=\"0\">\n";
		
		foreach ($formHiddenInputs  as $name => $value) {
			$form .= "<input type=\"hidden\" name=\"$name";  
			$form .= "\" value=\"$value";
			$form .= "\" >\n";
		}
		$form .= "</form>\n";
		return $form;
	}
	  

	 public static function GenerateForm($accessKey,$secretKey,$amount, $description, $referenceId, $immediateReturn,
                        $returnUrl, $abandonUrl, $processImmediate, $ipnUrl,$collectShippingAddress,
                        $signatureMethod,$recurringFrequency,$subscriptionPeriod,$recurringStartDate,$promotionAmount,$noOfPromotionTransactions ,
			$environment) {
		 if($environment=="prod"){
                                $endPoint = self::$PROD_END_POINT;
                                $imageLocation = self::$PROD_IMAGE_LOCATION;
                        }
                        else
                        {
                                $endPoint= self::$SANDBOX_END_POINT;
                                $imageLocation = self::$SANDBOX_IMAGE_LOCATION;
                        }

                $params = self::getSubscriptionParams($accessKey,$amount, $description, $referenceId, $immediateReturn,
                        $returnUrl, $abandonUrl, $processImmediate, $ipnUrl,$collectShippingAddress, $signatureMethod,$recurringFrequency,$subscriptionPeriod,$recurringStartDate,$promotionAmount,$noOfPromotionTransactions );

                $serviceEndPoint = parse_url($endPoint);
                $signature = SignatureUtils::signParameters($params, $secretKey,
                                self::$httpMethod, $serviceEndPoint['host'], $serviceEndPoint['path'],$signatureMethod);
                $params[self::SIGNATURE_KEYNAME] = $signature;
                $simplePayForm = self::getSubscriptionForm($params,$endPoint,$imageLocation);
                print $simplePayForm . "\n";
        }

}
?>